> ## Documentation Index
> Fetch the complete documentation index at: https://docs.semicola.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a creative on a campaign



## OpenAPI

````yaml /openapi/buyer.yaml post /api/v2/buyer/campaigns/{id}/creatives/create
openapi: 3.1.0
info:
  title: Semicola Exchange buyer API
  version: 2.0.0
  description: >-
    Buyer endpoints: advertisers, storefronts and connections, product
    discovery, campaigns, proposals, media buys, creatives and reporting. Every
    write accepts an Idempotency-Key header.
servers:
  - url: https://api.semicola.com
security:
  - bearerAuth: []
  - sessionCookie: []
tags:
  - name: Advertisers
  - name: Storefronts
  - name: Product Discovery
  - name: Campaigns
  - name: Media Buys
  - name: Update Proposals
  - name: Optimization Suggestions
  - name: Creatives
  - name: Catalogs
  - name: Property Lists
  - name: Audiences
  - name: Syndication
  - name: Reporting
  - name: Event Sources
  - name: Webhooks
  - name: Tasks
  - name: Audit Logs
  - name: Activity
paths:
  /api/v2/buyer/campaigns/{id}/creatives/create:
    post:
      tags:
        - Creatives
      summary: Create a creative on a campaign
      operationId: postBuyerCampaignsByIdCreativesCreate
      parameters:
        - name: id
          in: path
          required: true
          schema:
            type: string
            minLength: 1
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                  minLength: 1
                  maxLength: 200
                formatKind:
                  type: string
                  enum:
                    - image
                    - html5
                    - display_tag
                    - image_carousel
                    - video_hosted
                    - video_vast
                    - audio_hosted
                    - audio_daast
                    - sponsored_placement
                    - native_in_feed
                    - responsive_creative
                    - agent_placement
                    - custom
                formatId:
                  type: object
                  properties:
                    agentUrl:
                      type: string
                    id:
                      type: string
                  required:
                    - agentUrl
                    - id
                sourceAssets:
                  default: []
                  type: array
                  items:
                    type: object
                    properties:
                      assetId:
                        type: string
                      slot:
                        type: string
                    required:
                      - assetId
                      - slot
                copy:
                  type: object
                  propertyNames:
                    type: string
                  additionalProperties:
                    type: string
                clickUrl:
                  type: string
                  format: uri
                mode:
                  type: string
                  enum:
                    - draft
                    - complete
                message:
                  type: string
                  maxLength: 2000
                urlAsset:
                  type: object
                  properties:
                    url:
                      type: string
                      maxLength: 2048
                      format: uri
                    urlType:
                      type: string
                      enum:
                        - clickthrough
                        - tracker_pixel
                        - tracker_script
                        - vast
                    vastVersion:
                      type: string
                      enum:
                        - '2.0'
                        - '3.0'
                        - '4.0'
                        - '4.1'
                        - '4.2'
                        - '4.3'
                  required:
                    - url
                    - urlType
                webhookAsset:
                  type: object
                  properties:
                    url:
                      type: string
                      maxLength: 2048
                      format: uri
                    method:
                      default: POST
                      type: string
                      enum:
                        - GET
                        - POST
                    timeoutMs:
                      default: 500
                      type: integer
                      minimum: 10
                      maximum: 5000
                    responseType:
                      default: json
                      type: string
                      enum:
                        - html
                        - json
                        - xml
                        - javascript
                    security:
                      oneOf:
                        - type: object
                          properties:
                            method:
                              type: string
                              const: none
                          required:
                            - method
                        - type: object
                          properties:
                            method:
                              type: string
                              const: hmac_sha256
                            hmacHeader:
                              type: string
                              minLength: 1
                              maxLength: 100
                          required:
                            - method
                            - hmacHeader
                        - type: object
                          properties:
                            method:
                              type: string
                              const: api_key
                            apiKeyHeader:
                              type: string
                              minLength: 1
                              maxLength: 100
                          required:
                            - method
                            - apiKeyHeader
                  required:
                    - url
                    - security
                carouselCards:
                  maxItems: 10
                  type: array
                  items:
                    type: object
                    properties:
                      assetId:
                        type: string
                        minLength: 5
                      headline:
                        type: string
                        maxLength: 200
                      description:
                        type: string
                        maxLength: 1000
                      cta:
                        type: string
                        maxLength: 60
                      landingPageUrl:
                        type: string
                        maxLength: 2048
                        format: uri
                    required:
                      - assetId
                frequencyCaps:
                  type: array
                  items:
                    type: object
                    properties:
                      max_impressions:
                        type: integer
                        exclusiveMinimum: 0
                        maximum: 9007199254740991
                      window:
                        type: object
                        properties:
                          interval:
                            type: integer
                            exclusiveMinimum: 0
                            maximum: 9007199254740991
                          unit:
                            type: string
                            enum:
                              - minutes
                              - hours
                              - days
                              - campaign
                        required:
                          - interval
                          - unit
                    required:
                      - max_impressions
                      - window
                    additionalProperties: false
              required:
                - name
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    anyOf:
                      - type: object
                        properties:
                          id:
                            type: string
                            minLength: 4
                          advertiserId:
                            type: integer
                            exclusiveMinimum: 0
                            maximum: 2147483647
                          name:
                            type: string
                            minLength: 1
                          state:
                            type: string
                            enum:
                              - draft
                              - complete
                          formatKind:
                            anyOf:
                              - type: string
                                enum:
                                  - image
                                  - html5
                                  - display_tag
                                  - image_carousel
                                  - video_hosted
                                  - video_vast
                                  - audio_hosted
                                  - audio_daast
                                  - sponsored_placement
                                  - native_in_feed
                                  - responsive_creative
                                  - agent_placement
                                  - custom
                              - type: 'null'
                          formatId:
                            anyOf:
                              - type: object
                                properties:
                                  agentUrl:
                                    type: string
                                  id:
                                    type: string
                                  width:
                                    type: integer
                                    exclusiveMinimum: 0
                                    maximum: 9007199254740991
                                  height:
                                    type: integer
                                    exclusiveMinimum: 0
                                    maximum: 9007199254740991
                                  durationMs:
                                    type: integer
                                    exclusiveMinimum: 0
                                    maximum: 9007199254740991
                                required:
                                  - agentUrl
                                  - id
                                additionalProperties: false
                              - type: 'null'
                          formatLabel:
                            type:
                              - string
                              - 'null'
                          slots:
                            type: array
                            items:
                              type: object
                              properties:
                                slotId:
                                  type: string
                                kind:
                                  type: string
                                  enum:
                                    - asset
                                    - copy
                                assetId:
                                  type: string
                                  minLength: 5
                                value:
                                  type: string
                                  maxLength: 5000
                                crop:
                                  type: boolean
                              required:
                                - slotId
                                - kind
                              additionalProperties: false
                          copy:
                            anyOf:
                              - type: object
                                propertyNames:
                                  type: string
                                additionalProperties:
                                  type: string
                              - type: 'null'
                          clickUrl:
                            type:
                              - string
                              - 'null'
                          trackers:
                            anyOf:
                              - type: object
                                propertyNames:
                                  type: string
                                additionalProperties: {}
                              - type: 'null'
                          message:
                            type:
                              - string
                              - 'null'
                          urlAsset:
                            anyOf:
                              - type: object
                                properties:
                                  url:
                                    type: string
                                    maxLength: 2048
                                    format: uri
                                  urlType:
                                    type: string
                                    enum:
                                      - clickthrough
                                      - tracker_pixel
                                      - tracker_script
                                      - vast
                                  vastVersion:
                                    type: string
                                    enum:
                                      - '2.0'
                                      - '3.0'
                                      - '4.0'
                                      - '4.1'
                                      - '4.2'
                                      - '4.3'
                                required:
                                  - url
                                  - urlType
                                additionalProperties: false
                              - type: 'null'
                          webhookAsset:
                            anyOf:
                              - type: object
                                properties:
                                  url:
                                    type: string
                                    maxLength: 2048
                                    format: uri
                                  method:
                                    default: POST
                                    type: string
                                    enum:
                                      - GET
                                      - POST
                                  timeoutMs:
                                    default: 500
                                    type: integer
                                    minimum: 10
                                    maximum: 5000
                                  responseType:
                                    default: json
                                    type: string
                                    enum:
                                      - html
                                      - json
                                      - xml
                                      - javascript
                                  security:
                                    oneOf:
                                      - type: object
                                        properties:
                                          method:
                                            type: string
                                            const: none
                                        required:
                                          - method
                                        additionalProperties: false
                                      - type: object
                                        properties:
                                          method:
                                            type: string
                                            const: hmac_sha256
                                          hmacHeader:
                                            type: string
                                            minLength: 1
                                            maxLength: 100
                                        required:
                                          - method
                                          - hmacHeader
                                        additionalProperties: false
                                      - type: object
                                        properties:
                                          method:
                                            type: string
                                            const: api_key
                                          apiKeyHeader:
                                            type: string
                                            minLength: 1
                                            maxLength: 100
                                        required:
                                          - method
                                          - apiKeyHeader
                                        additionalProperties: false
                                required:
                                  - url
                                  - method
                                  - timeoutMs
                                  - responseType
                                  - security
                                additionalProperties: false
                              - type: 'null'
                          carouselCards:
                            anyOf:
                              - type: array
                                items:
                                  type: object
                                  properties:
                                    assetId:
                                      type: string
                                      minLength: 5
                                    headline:
                                      type: string
                                      maxLength: 200
                                    description:
                                      type: string
                                      maxLength: 1000
                                    cta:
                                      type: string
                                      maxLength: 60
                                    landingPageUrl:
                                      type: string
                                      maxLength: 2048
                                      format: uri
                                  required:
                                    - assetId
                                  additionalProperties: false
                              - type: 'null'
                          role:
                            type: string
                            enum:
                              - evergreen
                              - reference
                          promoted:
                            type: boolean
                          revision:
                            type: integer
                            minimum: 0
                            maximum: 9007199254740991
                          frequencyCaps:
                            anyOf:
                              - type: array
                                items:
                                  type: object
                                  properties:
                                    id:
                                      type: string
                                    targetLevel:
                                      type: string
                                      enum:
                                        - ADVERTISER
                                        - CAMPAIGN
                                        - CREATIVE
                                    targetId:
                                      type: string
                                    max_impressions:
                                      type: integer
                                      exclusiveMinimum: 0
                                      maximum: 9007199254740991
                                    window:
                                      type: object
                                      properties:
                                        interval:
                                          type: integer
                                          exclusiveMinimum: 0
                                          maximum: 9007199254740991
                                        unit:
                                          type: string
                                          enum:
                                            - minutes
                                            - hours
                                            - days
                                            - campaign
                                      required:
                                        - interval
                                        - unit
                                      additionalProperties: false
                                    createdAt:
                                      type: string
                                    updatedAt:
                                      type: string
                                    archivedAt:
                                      type:
                                        - string
                                        - 'null'
                                  required:
                                    - id
                                    - targetLevel
                                    - targetId
                                    - max_impressions
                                    - window
                                    - createdAt
                                    - updatedAt
                                    - archivedAt
                                  additionalProperties: false
                              - type: 'null'
                          createdAt:
                            type: string
                            format: date-time
                            pattern: >-
                              ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                          updatedAt:
                            type: string
                            format: date-time
                            pattern: >-
                              ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                          frequencyCapsNote:
                            type: string
                        required:
                          - id
                          - advertiserId
                          - name
                          - state
                          - formatKind
                          - formatId
                          - formatLabel
                          - slots
                          - copy
                          - clickUrl
                          - trackers
                          - message
                          - urlAsset
                          - webhookAsset
                          - carouselCards
                          - role
                          - promoted
                          - revision
                          - createdAt
                          - updatedAt
                        additionalProperties: false
                      - type: 'null'
                  error:
                    anyOf:
                      - type: object
                        properties:
                          code:
                            type: string
                          message:
                            type: string
                          field:
                            type: string
                          details: {}
                        required:
                          - code
                          - message
                        additionalProperties: false
                      - type: 'null'
                required:
                  - data
                  - error
                additionalProperties: false
        default:
          description: >-
            Error envelope `{data: null, error: {code, message, field?,
            details?}}`.
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: API key or OAuth access token.
    sessionCookie:
      type: apiKey
      in: cookie
      name: __Host-sc_session
      description: >-
        The app session: host-only on the api and sent only by the web app.
        Integrations use bearerAuth.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.